/***
 * Excerpted from "Domain-Driven Design Using Naked Objects",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/dhnako for more book information.
***/
@Override
public boolean pay(Integer amount) {
    warnUser("Put onto Account");
    setBalance(getBalance() + amount);
    return true;
}
@Override
public String validatePay(Integer amount) {
    int available = getLimit().intValue() - getBalance().intValue();
    return amount > available? "Amount exceeds available credit": null;
}
